#include "ukr_matlab.h"

void mexFunction(int nlhs, mxArray *plhs[], int nrhs,const mxArray *prhs[]) {
   UKR_Model model;
   UKR_G_Struct gs;
   UKR_Workspace W;
   
   const double *x;
   double con;
   double *g;

   if (nrhs<2) mexErrMsgTxt("Not enough arguments.");
   
   model = ukr_model_from_matlab(prhs[1]);

   if (model.X==NULL) mexErrMsgTxt("Model does not contain 'X'");
   
   x = ukr_mx_get_matrix(prhs[0], model.q, 1);
   if (x==NULL) mexErrMsgTxt("Parameter x must be a 'q x 1' vector.");
      
   if (!ukr_aux_alloc_workspace(model,&W)) mexErrMsgTxt("Sorry, out of memory.");
   
	plhs[1]=mxCreateDoubleMatrix(model.q,1,mxREAL);
	g=mxGetPr(plhs[1]);
   
   con = ukr_g_congrad(g,x,model,&W);
   
   ukr_aux_free_workspace(W);
	plhs[0]=mxCreateDoubleScalar(con);
}
