function [err,XQ_T] = ukr_aux_XQ_T(Xn, model, Mask,T)

[K,sumK,P] = ukr_kp_dists(sum(Xn.^2,1)',model,Mask);
[q,N]=size(Xn);

if sumK==0
   XQ_T = zeros(q,N);
   if isfield(model,'G')
      err = model.G(T,T);
   else
      err = sum(T.^2);
   end
   return;
end

switch(model.degree)
   case 0
      b = K/sumK;
      
      [err, M] = ukr_aux_err_m(b,model,T);
      
      XQ_T = Xn.*repmat(P'.*(M'-sum(b.*M)));
      return
   case 1
      Xi = [ones(1,N); Xn];
      KXiT = repmat(K,1,q+1).*Xi';
      
      Gamma = inv(Xi*KXiT);
      U = Gamma(1,:)*Xi;
      b = KXiT*Gamma(:,1);
      [err, M] = ukr_aux_err_m(b,model,T);
      MK = M.*K;
      Psi = Xi*MK;      
      GammaPsi = Gamma*Psi;
      PsiU = GammaPsi'*Xi; % Psi'*U;
      M_PsiU = M'-PsiU;      
      
      Gamma_m = Gamma(2:q+1,1);
      T = -Gamma_m*MK' + GammaPsi(2:q+1)*(U.*K') + Gamma_m*(PsiU.*K');
   
   case 2
      Xi = [ones(1,N); Xn; Xn.^2];
      KXiT = repmat(K,1,2*q+1).*Xi';

      Gamma = inv(Xi*KXiT);
      U = Gamma(1,:)*Xi;
      b = KXiT*Gamma(:,1);
      [err, M] = ukr_aux_err_m(b,model,T);
      MK = M.*K;
      Psi = Xi*MK;      
      GammaPsi = Gamma*Psi;
      PsiU = GammaPsi'*Xi; % Psi'*U;
      M_PsiU = M'-PsiU;

      Gamma_m = Gamma(2:q+1,1);
      Gamma_mq = Gamma((q+2):(2*q+1),1);   

      GPsi = GammaPsi(2:q+1);
      GPsiq = GammaPsi((q+2):(2*q+1));

      Gm0 = repmat(Gamma_m,1,N) + repmat(2*Gamma_mq,1,N).*Xn;
      Gma = repmat(GPsi,1,N) + repmat(2*GPsiq,1,N).*Xn;

      T = Gma.*repmat(U.*K',q,1) - Gm0.*(repmat(M_PsiU.*K',q,1));

   case 3
      Xi = [ones(1,N); Xn; Xn.^2; Xn(1,:).*Xn(2,:)];
      KXiT = repmat(K,1,6).*Xi';

      Gamma = inv(Xi*KXiT);
      U = Gamma(1,:)*Xi;
      b = KXiT*Gamma(:,1);
      [err, M] = ukr_aux_err_m(b,model,T);
      MK = M.*K;
      Psi = Xi*MK;
      GammaPsi = Gamma*Psi;
      PsiU = GammaPsi'*Xi; % Psi'*U;
      M_PsiU = M'-PsiU;

      Gm0 = repmat(Gamma(2:3,1),1,N) + repmat(2*Gamma(4:5,1),1,N).*Xn + Gamma(6,1)*Xn([2 1],:);
      Gma = repmat(GammaPsi(2:3,1),1,N) + repmat(2*GammaPsi(4:5,1),1,N).*Xn + GammaPsi(6,1)*Xn([2 1],:);

      T = Gma.*repmat(U.*K',2,1) - Gm0.*(repmat(M_PsiU.*K',2,1));
end

Qn = M_PsiU.*P'.*U;
XQ_T = Xn.*repmat(Qn,q,1) + T;

