function B = ukr_aux_lq_b(X,model,K) 
%function B = ukr_aux_lq_b(X,model,K) 

[q,N] = size(X);

modN = size(model.X,2);

if issparse(K)
   B = K;
else
   B = zeros(modN,N);
end

switch model.degree
   case 1
      e0 = [1; zeros(q,1)];
   
      for n=1:N
         Xi = [ones(1,modN) ; model.X - repmat(X(:,n),1,modN)];
         WX_T = repmat(K(:,n),1,q+1).*Xi';
         C = Xi*WX_T;
         B(:,n) = WX_T*(C\e0);
      end
   case 2
      e0 = [1; zeros(2*q,1)];   
      
      for n=1:N
         Xn = model.X - repmat(X(:,n),1,modN);
         Xi = [ones(1,modN) ; Xn ; Xn.^2 ];
         
         WX_T = repmat(K(:,n),1,q*2+1).*Xi';
         C = Xi*WX_T;
         B(:,n) = WX_T*(C\e0);
      end
   case 3
      if q~=2
         error 'If model.degree==2, model.q must be =2.';
      end
      e0 = [1;0;0;0;0;0];
      
      for n=1:N
         Xn = model.X - repmat(X(:,n),1,modN);
         Xi = [ones(1,modN) ; Xn ; Xn.^2; Xn(1,:).*Xn(2,:) ];
         
         WX_T = repmat(K(:,n),1,6).*Xi';
         C = Xi*WX_T;
         B(:,n) = WX_T*(C\e0);
      end
   otherwise
      error 'model.degree must be 1,2 (any model.q)  or 3 (model.q=2)';
end
      
