function [pen, grad] = ukr_densvar_penalty(X, model)
%function [pen, grad] = ukr_densvar_penalty(X, model)

error(nargchk(2, 2, nargin))

% get dimensions:
[q N] = size(X);

% compute distance and kernel matrices
[K,sumK,P] = ukr_kp_dists(ukr_aux_distances(X),model);

dens = sumK/N;
d = dens - mean(dens);

pen = (N/2)*sum(d.^2);

if nargout > 1
   Q = P.*repmat(d,N,1);
   Q=Q+Q';
   grad = X*Q - X.*repmat(sum(Q),q,1);
end

