function [pen, grad] = ukr_ext_penalty(X, model)
% function [pen, grad] = ukr_ext_penalty(X, model)
%
% UKR extension of latent space penalty function

error(nargchk(1, 2, nargin))

[q,N]=size(X);

pen = (0.5/N)*norm(X,'fro')^2;

if nargout > 1
   grad = (1/N)*X;
end
