function [con,grad] = ukr_g_congrad(X,model,varargin)
% function [con,grad] = ukr_g_congrad(X,model,varargin)
%
% Density constraint and gradient used in ukr_g
% Normally, you won't use this directly.
%
[q,N] = size(model.X);

[K,sumK,P] = ukr_kp_dists(ukr_aux_distances(model.X,X), model);

con=model.eta-sumK/N;
sumP=sum(P);

if nargout>1
   grad=-(1/N)*(model.X*P-X*diag(sumP));
end
