function M = ukr_M(X,model)

[q Nh]=size(model.X);
[qx N] = size(X);

Xh=model.X;

if q~=qx 
   error 'Dimensions do not match (X and model.X)';
end

DX = distances(Xh,X);
  
switch model.kernel_l
  case 'Gaussian';

    K = exp(-0.5*DX);
    
    sumK=sum(K);
    
    K = K.*repmat(sumK.^(-1),Nh,1);
    K1 = K;
    K2 = K;
    
  case 'Triweight';
  
    E = 1-DX;
    E(E<0)=0;
    
    K = E.^3;
    K1 = 6*E.^2;
    K2 = 12*E;
    
    sumK=sum(K);
    
    K = K.*repmat(sumK.^(-1),Nh,1);
    K1 = K1.*repmat(sumK.^(-1),Nh,1);
    K2 = K2.*repmat(sumK.^(-1),Nh,1);
    
%  case 'Quartic';
   otherwise 
      error 'Unsupported kernel';
end

M = zeros(Nh,Nh);

for n=1:N

   bmu = zeros(q,Nh);
   bmunu = zeros(q,q,Nh);
   for i=1:Nh
      d=X(:,n) - Xh(:,i);
      bmu(:,i) = K1(i,n)*d;
      bmunu(:,:,i) = K2(i,n)*d*d' + K1(i,n)*eye(q);
   end
   sbmu = sum(bmu,2);
   sbmunu = sum(bmunu,3);
   sbmu_sbnu = sbmu*sbmu';
   Q=bmunu;   
   
   for i=1:Nh
      qi = -K(i,n) * sbmunu - bmu(:,i)*sbmu' - sbmu*bmu(:,i)' + 2*K(i,n)*sbmu_sbnu;
      Q(:,:,i)=Q(:,:,i)+qi;
   end
   Q=reshape(Q,q*q,Nh);
   M = M + Q'*Q;
   
end
