function [X,f] = ukr_opt_online(Xinit,maxiter,model,varargin)
% function [X,f] = ukr_opt_online(Xinit,maxiter,model,varargin)

disp = 0;
if isfield(model,'display')
   disp = model.display;
end

X=Xinit;
[q,N]=size(X);
gradBound2=(10^-16)*length(X);

rs = ukr_rprop_init(X);

[f,g]=ukr_errgrad(X,model,varargin{:});

abs2g=sum(sum(g.^2));
found=abs2g<gradBound2;

lambda = 0.1;

iter=0;
while (~found)&(iter<=maxiter)

  
   if disp
      fprintf(1,'[%4i] %f\n',iter,f);
   end

   rp = randperm(N);
   
   %lambda = lambda * 0.99;
   
   for n=1:N
      [e,g] = ukr_errgrad_ol(X,model,rp(n),varargin{:});
      X = X - lambda*g;
   end
   
   if isfield(model,'label')
      plotLab(X,model.label);
      drawnow;
   end
%   lambda=lambda*0.99;
   
   [f,g]=ukr_errgrad(X,model,varargin{:});
   
   abs2g=sum(sum(g.^2));

   found=abs2g<gradBound2;
   iter=iter+1;
end

%fprintf(1,'%i iterations, |g|=%f\n',iter-1,sqrt(abs2g));
