function [X,f] = ukr_opt_unc(fungrad,Xinit,maxiter,model,varargin)
% function [X,f] = ukr_opt_unc(fungrad,Xinit,maxiter,model,varargin)

disp = 0;
if isfield(model,'display')
   disp = model.display;
end

X=Xinit;
gradBound2=(10^-16)*length(X);

rs = ukr_rprop_init(X);

[f,g]=feval(fungrad,X,model,varargin{:});

abs2g=sum(sum(g.^2));
found=abs2g<gradBound2;

iter=0;
while (~found)&(iter<=maxiter)
  
   if disp
      fprintf(1,'[%4i] %f\n',iter,f);
   end
   
   [X, rs]=ukr_rprop_adapt(X, rs, g);
   
   oldF=f;
   
   [f,g]=feval(fungrad,X,model,varargin{:});
   
   if isnan(f)
     warning('Objective function and/or penalty returned NaN');
     X=rs.oldX;
     f=oldF;
     return;
   end
   
   abs2g=sum(sum(g.^2));

   found=abs2g<gradBound2;
   iter=iter+1;
end

%fprintf(1,'%i iterations, |g|=%f\n',iter-1,sqrt(abs2g));
